﻿using System;
using Wisej.Web;
using WisejUITests.Views;

namespace WisejUITests
{
    public partial class MainPage : Page
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void dgvRejectsSpaces_Click(object sender, EventArgs e)
        {
            // TODO: onclose event is broken (needs owner parameter)
            Application.Hash = string.Empty;

            Application.Hash = "DgvRejectsSpaces";
        }

        private void textBoxBinding_Click(object sender, EventArgs e)
        {
            // TODO: onclose event is broken (needs owner parameter)
            Application.Hash = string.Empty;

            Application.Hash = "TextBoxBinding";
        }

        private void MainPage_Load(object sender, EventArgs args)
        {
            // detect changes to the applicationHash in the URL.
            Application.HashChanged += (s, e) => { ShowWindowFromURL(e.Hash); };

            // handle the first applicationHash, if any.
            ShowWindowFromURL(Application.Hash);
        }

        private void ShowWindowFromURL(string applicationHash)
        {
            // show the user is in the URL.
            int windowId;
            if (int.TryParse(applicationHash, out windowId))
                OpenWindow(windowId);
            else
                OpenWindow(applicationHash);
        }

        private void OpenWindow(string windowName)
        {
            if (!string.IsNullOrEmpty(windowName))
            {
                // dispose the dialog in case it's already open.
                if (Application.OpenForms[windowName] != null)
                    Application.OpenForms[windowName].Dispose();
            }

            // create the dialog in a using block to make sure it gets disposed.
            using (var testWindow = GetTestWindow(windowName))
            {
                if (testWindow != null)
                {
                    // show the dialog and handle the closing event asynchronously (modeless).

                    // TODO: onclose event is broken (needs owner parameter)
                    testWindow.ShowDialog(result =>
                    {
                        // when the dialog is closed, remove the deep linking applicationHash.
                        Application.Hash = string.Empty;
                    });
                }
            }
        }

        private void OpenWindow(int windowId)
        {
            OpenWindow(GetWindowName(windowId));
        }

        private string GetWindowName(int windowId)
        {
            switch (windowId)
            {
                case 1:
                    return "DgvRejectsSpaces";
                case 2:
                    return "TextBoxBinding";
                default:
                    return string.Empty;
            }
        }

        private Form GetTestWindow(string windowName)
        {
            switch (windowName)
            {
                case "DgvRejectsSpaces":
                    return new DgvRejectsSpaces();
                case "TextBoxBinding":
                    return new TextBoxBinding();
                default:
                    return null;
            }
        }
    }
}